
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Ore_bodiesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ore_bodies = await db.ore_bodies.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        classification: data.classification
        ||
        null
            ,
            
        ore_type: data.ore_type
        ||
        null
            ,
            
        head_grade_au_gpt: data.head_grade_au_gpt
        ||
        null
            ,
            
        tonnage_mt: data.tonnage_mt
        ||
        null
            ,
            
        mineralogy_json: data.mineralogy_json
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await ore_bodies.setProject( data.project || null, {
            transaction,
        });
        
        await ore_bodies.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return ore_bodies;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const ore_bodiesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                classification: item.classification
            ||
            null
            ,
            
                ore_type: item.ore_type
            ||
            null
            ,
            
                head_grade_au_gpt: item.head_grade_au_gpt
            ||
            null
            ,
            
                tonnage_mt: item.tonnage_mt
            ||
            null
            ,
            
                mineralogy_json: item.mineralogy_json
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const ore_bodies = await db.ore_bodies.bulkCreate(ore_bodiesData, { transaction });

        // For each item created, replace relation files
        

        return ore_bodies;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const ore_bodies = await db.ore_bodies.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.classification !== undefined) updatePayload.classification = data.classification;
        
        
        if (data.ore_type !== undefined) updatePayload.ore_type = data.ore_type;
        
        
        if (data.head_grade_au_gpt !== undefined) updatePayload.head_grade_au_gpt = data.head_grade_au_gpt;
        
        
        if (data.tonnage_mt !== undefined) updatePayload.tonnage_mt = data.tonnage_mt;
        
        
        if (data.mineralogy_json !== undefined) updatePayload.mineralogy_json = data.mineralogy_json;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await ore_bodies.update(updatePayload, {transaction});

        
        
        if (data.project !== undefined) {
            await ore_bodies.setProject(
              
              data.project,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await ore_bodies.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return ore_bodies;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const ore_bodies = await db.ore_bodies.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of ore_bodies) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of ore_bodies) {
                await record.destroy({transaction});
            }
        });


        return ore_bodies;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const ore_bodies = await db.ore_bodies.findByPk(id, options);

        await ore_bodies.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await ore_bodies.destroy({
            transaction
        });

        return ore_bodies;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const ore_bodies = await db.ore_bodies.findOne(
            { where },
            { transaction },
        );

        if (!ore_bodies) {
            return ore_bodies;
        }

        const output = ore_bodies.get({plain: true});

        
        
        
        
        
        
        
        
        
        output.samples_ore_body = await ore_bodies.getSamples_ore_body({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.project = await ore_bodies.getProject({
            transaction
        });
        
        
        output.organizations = await ore_bodies.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.projects,
        as: 'project',
        
        where: filter.project ? {
          [Op.or]: [
            { id: { [Op.in]: filter.project.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.project.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ore_bodies',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.mineralogy_json) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ore_bodies',
                        'mineralogy_json',
                        filter.mineralogy_json,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'ore_bodies',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.head_grade_au_gptRange) {
                const [start, end] = filter.head_grade_au_gptRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    head_grade_au_gpt: {
                    ...where.head_grade_au_gpt,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    head_grade_au_gpt: {
                    ...where.head_grade_au_gpt,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.tonnage_mtRange) {
                const [start, end] = filter.tonnage_mtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    tonnage_mt: {
                    ...where.tonnage_mt,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    tonnage_mt: {
                    ...where.tonnage_mt,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.classification) {
                where = {
                    ...where,
                classification: filter.classification,
            };
            }
            
            if (filter.ore_type) {
                where = {
                    ...where,
                ore_type: filter.ore_type,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.ore_bodies.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'ore_bodies',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.ore_bodies.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

